/*******************************************************************************
 * Ȩ (C)2015, LINKO SEMICONDUCTOR Co.ltd
 *
 * ļƣ lks32mc08x_hall.h
 * ļʶ
 * ժҪ HALLͷļ
 * ˵ 
 * ǰ汾 V 1.0
 *     ߣ 
 * ڣ 
 *
 * ޸ļ¼1
 * ޸ڣ
 *   ţV 1.0
 *   ˣ
 * ޸ݣ
 *
 * ޸ļ¼2
 * ޸ڣ
 *   ţ
 *   ˣ
 * ޸ݣ
 *
 *******************************************************************************/
 
#ifndef __lks32mc08x_HALL_H
#define __lks32mc08x_HALL_H


/* Includes ------------------------------------------------------------------*/
#include "lks32mc08x.h"
#include "basic.h"


typedef struct
{
   __IO uint32_t CFG;
   __IO uint32_t INFO;
   __IO uint32_t WIDTH;
   __IO uint32_t TH;
	 __IO uint32_t CNT;
	
}HALL_TypeDef;

typedef struct
{
   uint16_t FilterLen;                /*˲,0Ӧ1,1023Ӧ1024˲*/
   uint8_t ClockDivision;            /*Ƶ 0~3:/1 /2 /4 /8*/
   uint8_t Filter75_Ena;             /*ʹܵһ7/5˲,ߵƽЧ*/
   uint8_t HALL_Ena;                 /*ʹHALL,ߵƽЧ*/
   uint8_t Capture_IRQ_Ena;          /*HALLźű仯жʹ,ߵƽЧ*/
   uint8_t OverFlow_IRQ_Ena;         /*HALLжʹ,ߵƽЧ*/
   uint32_t CountTH;                  /*HALLֵ*/
	 uint8_t softIE;                   /* жʹ */
}HALL_InitTypeDef;

#define HALL_CLK_DIV1 ((uint32_t)0x00)
#define HALL_CLK_DIV2 ((uint32_t)0x01)
#define HALL_CLK_DIV4 ((uint32_t)0x02)
#define HALL_CLK_DIV8 ((uint32_t)0x03)

#define HALL_CAPTURE_EVENT  ((uint32_t)0x00010000)
#define HALL_OVERFLOW_EVENT ((uint32_t)0x00020000)

void HALL_Init(HALL_InitTypeDef* HALL_InitStruct);
void HALL_StructInit(HALL_InitTypeDef* HALL_InitStruct);

uint32_t HALL_GetFilterValue(void);
uint32_t HALL_GetCaptureValue(void);
uint32_t HALL_GetCount(void);

uint32_t HALL_IsCaptureEvent(void);
uint32_t HALL_IsOverFlowEvent(void);

void HALL_Clear_IRQ(void);

#endif /*__lks32mc08x_HALL_H */



/************************ (C) COPYRIGHT LINKO SEMICONDUCTOR *****END OF FILE****/
