/*******************************************************************************
 * Ȩ (C)2015, LINKO SEMICONDUCTOR Co.ltd
 *
 * ļƣ lks32mc08x_tim.h
 * ļʶ
 * ժҪ TIMͷļ
 * ˵ 
 * ǰ汾 V 1.0
 *     ߣ 
 * ڣ 
 *
 * ޸ļ¼1
 * ޸ڣ
 *   ţV 1.0
 *   ˣ
 * ޸ݣ
 *
 * ޸ļ¼2
 * ޸ڣ
 *   ţ
 *   ˣ
 * ޸ݣ
 *
 *******************************************************************************/
 
#ifndef __lks32mc08x_TIM_H
#define __lks32mc08x_TIM_H

/* Includes ------------------------------------------------------------------*/

#include "basic.h"


typedef struct
{
	__IO uint32_t CFG;
	__IO uint32_t TH;
	__IO uint32_t CNT;
	__IO uint32_t CMPT0;
	__IO uint32_t CMPT1;
	__IO uint32_t EVT;
}TIM_TimerTypeDef;

typedef struct
{
	__IO uint32_t CFG;
	__IO uint32_t TH;
	__IO uint32_t CNT;
}TIM_ECDTypeDef;



#define TIM_Clk_Div1          0x00         /*TimerƵ128M*/   
#define TIM_Clk_Div2          0x01         /*TimerƵ64M*/
#define TIM_Clk_Div4          0x02         /*TimerƵ32M*/
#define TIM_Clk_Div8          0x03         /*TimerƵ16M*/

#define ECD_Clk_Div1          0x00         /*ECDƵ128M*/   
#define ECD_Clk_Div2          0x01         /*ECDƵ64M*/
#define ECD_Clk_Div4          0x02         /*ECDƵ32M*/
#define ECD_Clk_Div8          0x03         /*ECDƵ16M*/

/*жʹö*/
typedef enum
{
   Timer_IRQEna_None = 0,
   Timer_IRQEna_Zero = BIT0,     /*ʹܹж*/
   Timer_IRQEna_CH0 = BIT1,      /*ʹCH0жϣȽϡж*/
   Timer_IRQEna_CH1 = BIT2,      /*ʹCH1жϣȽϡж*/
   Timer_IRQEna_All = 0x07       /*ʹTimerȫж*/
}Timer_IRQEnaDef;

/*жϱ־*/
#define TIMER0_IF_Zero  BIT0     /*Timer0 ж*/
#define TIMER0_IF_CH0   BIT1     /*Timer0 CH0жϣȽϻ򲶻ж*/
#define TIMER0_IF_CH1   BIT2     /*Timer0 CH1жϣȽϻ򲶻ж*/
#define TIMER1_IF_Zero  BIT3     /*Timer1 ж*/
#define TIMER1_IF_CH0   BIT4     /*Timer1 CH0жϣȽϻ򲶻ж*/
#define TIMER1_IF_CH1   BIT5     /*Timer1 CH1жϣȽϻ򲶻ж*/
#define TIMER2_IF_Zero  BIT6     /*Timer2 ж*/
#define TIMER2_IF_CH0   BIT7     /*Timer2 CH0жϣȽϻ򲶻ж*/
#define TIMER2_IF_CH1   BIT8     /*Timer2 CH1жϣȽϻ򲶻ж*/
#define TIMER3_IF_Zero  BIT9     /*Timer3 ж*/
#define TIMER3_IF_CH0   BIT10    /*Timer3 CH0жϣȽϻ򲶻ж*/
#define TIMER3_IF_CH1   BIT11    /*Timer3 CH1жϣȽϻ򲶻ж*/


/*жʹö*/
#define ECD_IRQEna_None      0     /*ʹ*/
#define ECD_IRQEna_UnderFlow BIT0  /*ʹж*/
#define ECD_IRQEna_OverFlow  BIT1  /*ʹж*/

/*жϱ־*/
#define ECD0_IF_UNDERFLOW  BIT12 /*Encoder0ж*/
#define ECD0_IF_OVERFLOW   BIT13 /*Encoder0ж*/
#define ECD1_IF_UNDERFLOW  BIT14 /*Encoder1ж*/
#define ECD1_IF_OVERFLOW   BIT15 /*Encoder1ж*/

/*ģʽ*/
#define TIMER_CapMode_None     ((uint32_t)0x00000000)   /*޲*/
#define TIMER_CapMode_Rise     ((uint32_t)0x00000001)   /*ز*/
#define TIMER_CapMode_Fall     ((uint32_t)0x00000002)   /*½ز*/
#define TIMER_CapMode_RiseFall ((uint32_t)0x00000003)   /*˫ز*/

#define TIMER_OPMode_CAP ((uint32_t)0x0000001)    /*ģʽ*/
#define TIMER_OPMode_CMP ((uint32_t)0x0000000)    /*Ƚģʽ*/


#define ECD_Mode_T1              ((uint32_t)0x00) /*counting on T1*/
#define ECD_Mode_T1_T2           ((uint32_t)0x01) /*counting on T1&T2*/
#define ECD_Mode_CCWSIGN         ((uint32_t)0x02) /*CCW+SIGN, ź*/
#define ECD_Mode_CCWCW           ((uint32_t)0x03) /*CCW+CW, ź*/
#define ECD_Mode_CCWSIGN_UpDown  ((uint32_t)0x06) /*CCW+SIGN updown, źŵ*/
#define ECD_Mode_CCWCW_UpDown    ((uint32_t)0x07) /*CCW+CW updown, źŵ*/


typedef struct
{
   uint32_t Timer_CH0_WorkMode;  /*channel0ģʽ:ģʽȽģʽ*/
   uint32_t Timer_CH0_CapMode;   /*channel0ģʽ:ء½ء˫*/
   uint32_t Timer_CH0Output;     /*ʱȽģʽIO*/

   uint32_t Timer_CH1_WorkMode;  /*channel1ģʽ:ģʽȽģʽ*/
   uint32_t Timer_CH1_CapMode;   /*channel1ģʽ:ء½ء˫*/
   uint32_t Timer_CH1Output;     /*ʱȽģʽIO*/

   uint32_t Timer_TH;            /*ʱ*/
   uint32_t Timer_CMP0;          /*CH0Ƚϼֵ*/
   uint32_t Timer_CMP1;          /*CH1Ƚϼֵ*/

   uint32_t Timer_Filter0;    /*CH0˲Ƶ, 0:˲ N:˲õʱϵͳʱNƵ*/
   uint32_t Timer_Filter1;    /*CH1˲Ƶ*/

   uint32_t Timer_ClockDiv;      /*ʱƵ*/
   uint32_t Timer_IRQEna;
}TIM_TimerInitTypeDef;

typedef struct
{
   uint32_t ECD_Mode;
   uint32_t ECD_TH;
   uint32_t ECD_ClockDiv;
   uint32_t ECD_Filter0;
   uint32_t ECD_Filter1;
   uint32_t ECD_IRQEna;
}TIM_ECDInitTypeDef;


/*Timerʼ*/
void TIM_TimerInit(TIM_TimerTypeDef *TIMERx, TIM_TimerInitTypeDef *TIM_TimerInitStruct);
void TIM_TimerStrutInit(TIM_TimerInitTypeDef *TIM_TimerInitStruct);
// void TIM_StartTimer(TIM_TimerTypeDef *TIMERx);
// void TIM_StopTimer(TIM_TimerTypeDef *TIMERx);
void TIM_TimerCmd(TIM_TimerTypeDef *TIMERx, FuncState state);

/*TIMж*/
uint32_t TIM_GetIRQFlag(void);
/*TIMж*/
void TIM_ClearIRQFlag(uint32_t tempFlag);

uint32_t TIM_Timer_GetCount(TIM_TimerTypeDef *TIM_TIMERx);
uint32_t TIM_Timer_GetCMPT0(TIM_TimerTypeDef *TIM_TIMERx);
uint32_t TIM_Timer_GetCMPT1(TIM_TimerTypeDef *TIM_TIMERx);

/*ECDʼ*/
void TIM_ECDInit(TIM_ECDTypeDef *ECDx, TIM_ECDInitTypeDef *TIM_ECDInitStruct);
void TIM_ECDStructInit(TIM_ECDInitTypeDef *TIM_ECDInitStruct);
// void TIM_StartECD(TIM_ECDTypeDef *ECDx);
// void TIM_StopECD(TIM_ECDTypeDef *ECDx);
void TIM_ECDCmd(TIM_ECDTypeDef *ECDx, FuncState state);

uint32_t TIM_ECD_GetCount(TIM_ECDTypeDef *TIM_ECDx);

#endif /*__lks32mc08x_TIM_H */



/************************ (C) COPYRIGHT LINKO SEMICONDUCTOR *****END OF FILE****/
