/*******************************************************************************
 * Ȩ (C)2015, LINKO SEMICONDUCTOR Co.ltd
 *
 * ļƣ lks32mc081_hall.c
 * ļʶ
 * ժҪ HALL
 * ˵ 
 * ǰ汾 V 1.0
 *     ߣ 
 * ڣ 
 *
 * ޸ļ¼1
 * ޸ڣ
 *   ţV 1.0
 *   ˣ
 * ޸ݣ
 *
 * ޸ļ¼2
 * ޸ڣ
 *   ţ
 *   ˣ
 * ޸ݣ
 *
 *******************************************************************************/
#include "lks32mc08x_hall.h"
#include "lks32mc08x.h"

/*******************************************************************************
 ƣ    void HALL_Init(HALL_InitTypeDef* HALL_InitStruct)
     HALLʼ
 ı    
     
     
   ֵ    
 ˵
 ޸      汾          ޸            ޸
 -----------------------------------------------------------------------------
 2016/04/19      V1.0           cfwu          
 *******************************************************************************/
void HALL_Init(HALL_InitTypeDef* HALL_InitStruct)
{
   HALL->CFG = (HALL_InitStruct->FilterLen) | (HALL_InitStruct->ClockDivision << 16)
              | (HALL_InitStruct->Filter75_Ena << 20) | (HALL_InitStruct->HALL_Ena << 24)
              | (HALL_InitStruct->Capture_IRQ_Ena << 28) | (HALL_InitStruct->OverFlow_IRQ_Ena << 29)
	            | (HALL_InitStruct->softIE << 30);
   HALL->TH = HALL_InitStruct->CountTH;
   HALL->INFO = 0;
}

/*******************************************************************************
 ƣ    void HALL_StructInit(HALL_InitTypeDef* HALL_InitStruct)
     HALLṹʼ
 ı    
     
     
   ֵ    
 ˵
 ޸      汾          ޸            ޸
 -----------------------------------------------------------------------------
 2016/04/19      V1.0           cfwu          
 *******************************************************************************/
void HALL_StructInit(HALL_InitTypeDef* HALL_InitStruct)
{
   HALL_InitStruct->FilterLen = 1023;
   HALL_InitStruct->ClockDivision = HALL_CLK_DIV1;
   HALL_InitStruct->Filter75_Ena = ENABLE;
   HALL_InitStruct->HALL_Ena = ENABLE;
   HALL_InitStruct->Capture_IRQ_Ena = ENABLE;
   HALL_InitStruct->OverFlow_IRQ_Ena = DISABLE;
   HALL_InitStruct->CountTH = 1000;
	 HALL_InitStruct->softIE = DISABLE;
}

/*******************************************************************************
 ƣ    uint32_t HALL_GetFilterValue(void)
     ȡHALLֵ˲
 ı    
     
     
   ֵ    
 ˵
 ޸      汾          ޸            ޸
 -----------------------------------------------------------------------------
 2016/04/19      V1.0           cfwu          
 *******************************************************************************/
uint32_t HALL_GetFilterValue(void)
{
   return (HALL->INFO & 0x07);	
}

/*******************************************************************************
 ƣ    uint32_t HALL_GetCaptureValue(void)
     ȡHALLֵHALL¼ʱ
 ı    
     
     
   ֵ    
 ˵
 ޸      汾          ޸            ޸
 -----------------------------------------------------------------------------
 2016/04/19      V1.0           cfwu          
 *******************************************************************************/
uint32_t HALL_GetCaptureValue(void)
{
   return (HALL->INFO>>8) & 0x07;	
}

/*******************************************************************************
 ƣ    uint32_t HALL_GetCount(void)
     ȡHALLֵ
 ı    
     
     
   ֵ    
 ˵
 ޸      汾          ޸            ޸
 -----------------------------------------------------------------------------
 2016/04/19      V1.0           cfwu          
 *******************************************************************************/
uint32_t HALL_GetCount(void)
{
   return HALL->CNT;
}

/*******************************************************************************
 ƣ    uint32_t HALL_IsCaptureEvent(void)
     ǷHALLźű仯¼
 ı    
     
     
   ֵ    
 ˵
 ޸      汾          ޸            ޸
 -----------------------------------------------------------------------------
 2016/04/19      V1.0           cfwu          
 *******************************************************************************/
uint32_t HALL_IsCaptureEvent(void)
{
   return (HALL->INFO & HALL_CAPTURE_EVENT);
}

/*******************************************************************************
 ƣ    uint32_t HALL_IsOverFlowEvent(void)
     ǷHALL¼
 ı    
     
     
   ֵ    
 ˵
 ޸      汾          ޸            ޸
 -----------------------------------------------------------------------------
 2016/04/19      V1.0           cfwu          
 *******************************************************************************/
uint32_t HALL_IsOverFlowEvent(void)
{
   return (HALL->INFO & HALL_OVERFLOW_EVENT);
}

/*******************************************************************************
 ƣ    void HALL_Clear_IRQ(void)
     ͨINFOַд
 ı    
     
     
   ֵ    
 ˵
 ޸      汾          ޸            ޸
 -----------------------------------------------------------------------------
 2016/04/19      V1.0           cfwu          
 *******************************************************************************/
void HALL_Clear_IRQ(void)
{
   uint32_t temp = HALL->INFO & 0xFFFCFFFF;
   HALL->INFO = temp;
}


/************************ (C) COPYRIGHT LINKO SEMICONDUCTOR *****END OF FILE****/
