/*******************************************************************************
 * Ȩ (C)2015, LINKO SEMICONDUCTOR Co.ltd
 *
 * ļƣ lks32mc08x_sys.c
 * ļʶ
 * ժҪ SYS
 * ˵ 
 * ǰ汾 V 1.0
 *     ߣ 
 * ڣ 
 *
 * ޸ļ¼1
 * ޸ڣ
 *   ţV 1.0
 *   ˣ
 * ޸ݣ
 *
 * ޸ļ¼2
 * ޸ڣ
 *   ţ
 *   ˣ
 * ޸ݣ
 *
 *******************************************************************************/
#include "lks32mc08x_sys.h"
#include "lks32mc08x.h"


/*******************************************************************************
 ƣ    void SYS_Init(SYS_InitTypeDef* SYS_InitStruct)
     SYSģʼ
 ı    
     SYS_InitTypeDef* SYS_InitStruct
     
   ֵ    
 ˵
 ޸      汾          ޸            ޸
 -----------------------------------------------------------------------------
 2016/07/02      V1.0           cfwu          
 *******************************************************************************/
void SYS_Init(SYS_InitTypeDef* SYS_InitStruct)
{
   uint32_t RCHPd, XTALPdn;
   uint32_t tmp1, tmp2;

   tmp1 = SYS_AFE_REG6;
   tmp1 &= 0x7FFF;
   tmp1 |= (SYS_InitStruct->PLL_SrcSel << 15);
   SYS_AFE_REG6 = tmp1;
	
   if (SYS_InitStruct->PLL_SrcSel == SYS_PLLSRSEL_CRYSTAL)
   {
      RCHPd = ENABLE;         /*RCH(4MHz)ʱӹر*/
      XTALPdn = ENABLE;       /*·*/
   }
   else
   {
      RCHPd = DISABLE;        /*RCH(4MHz)ʱӲر*/
      XTALPdn = DISABLE;      /*·*/
   }
	 
   tmp2 = SYS_AFE_REG5;
   tmp2 &= 0xBBFF;
   tmp2 |= (RCHPd << 10);
   tmp2 |= (XTALPdn << 14);
   SYS_AFE_REG5 = tmp2;
	
   SYS_CLK_CFG = SYS_InitStruct->PLL_DivSel + (SYS_InitStruct->PLL_ReDiv << 8);
   SYS_RST_CFG = SYS_InitStruct->WDT_Ena | (SYS_InitStruct->PORFilter_Ena << 1);
	
   SYS_CLK_DIV0 = SYS_InitStruct->Clk_DivSPI;
   SYS_CLK_DIV2 = SYS_InitStruct->Clk_DivUART;
   SYS_CLK_FEN = SYS_InitStruct->Clk_FEN;
}

/*******************************************************************************
 ƣ    void SYS_StructInit(SYS_InitTypeDef* SYS_InitStruct)
     SYSṹʼ
 ı    
     SYS_InitTypeDef* SYS_InitStruct
     
   ֵ    
 ˵
 ޸      汾          ޸            ޸
 -----------------------------------------------------------------------------
 2016/07/02      V1.0           cfwu          
 *******************************************************************************/
void SYS_StructInit(SYS_InitTypeDef* SYS_InitStruct)
{
   SYS_InitStruct->PLL_SrcSel = SYS_PLLSRSEL_RCH;
   SYS_InitStruct->PLL_DivSel = 0xFF;
   SYS_InitStruct->PLL_ReDiv = SYS_PLLREDIV_1;

   SYS_InitStruct->Clk_DivSPI = SYS_Clk_SPIDiv1;
   SYS_InitStruct->Clk_DivUART = SYS_Clk_UARTDiv1;
   SYS_InitStruct->Clk_FEN = 0;

   SYS_InitStruct->WDT_Ena = DISABLE;
   SYS_InitStruct->PORFilter_Ena = DISABLE;
}

/*******************************************************************************
 ƣ    void SYS_ClearRst(void)
     SYSλ־
 ı    
     
     
   ֵ    
 ˵    ڸλ¼ڵʱִҪһʱ䣬Ӧ¼״̬
 ޸      汾          ޸            ޸
 -----------------------------------------------------------------------------
 2016/5/24      V1.0           cfwu          
 *******************************************************************************/
void SYS_ClearRst(void)
{
   SYS_CLR_RST = 0xDEAD;
}

/*******************************************************************************
 ƣ    uint32_t SYS_GetRstSource(void)
     SYSλԴź
 ı    
     
     
   ֵ    
 ˵
 ޸      汾          ޸            ޸
 -----------------------------------------------------------------------------
 2016/5/24      V1.0           cfwu          
 *******************************************************************************/
uint32_t SYS_GetRstSource(void)
{
	return SYS_RST_SRC;
}

/*******************************************************************************
 ƣ    void SYS_FallSleep(void)
     ϵͳ״̬
 ı    
     
     
   ֵ    
 ˵    
 ޸      汾          ޸            ޸
 -----------------------------------------------------------------------------
 2016/5/24      V1.0           cfwu          
 *******************************************************************************/
void SYS_FallSleep(void)
{
   SYS_CLK_SLP = 0xDEAD;
}

/*******************************************************************************
 ƣ    void SYS_SetWakeInterval(uint32_t nInterval)
     ߻
 ı    
     
     
   ֵ    
 ˵    
 ޸      汾          ޸            ޸
 -----------------------------------------------------------------------------
 2016/5/24      V1.0           cfwu          
 *******************************************************************************/
void SYS_SetWakeInterval(uint32_t nInterval)
{
   uint32_t tempReg = SYS_RST_CFG;
   tempReg |= (nInterval << 2);
   SYS_RST_CFG = tempReg;
}

/*******************************************************************************
 ƣ    void SYS_EnableWatchDog(void)
     ʹܿŹ
 ı    
     
     
   ֵ    
 ˵    
 ޸      汾          ޸            ޸
 -----------------------------------------------------------------------------
 2016/6/28      V1.0           cfwu          
 *******************************************************************************/
void SYS_EnableWatchDog(void)
{
   uint32_t tempReg = SYS_RST_CFG;
	 SYS_WR_PROTECT = 0x7a83;  //,0x7a83
   tempReg |= BIT0;
	//ʹWD
   SYS_RST_CFG = tempReg;
	 SYS_WR_PROTECT = 0x00;
}

/*******************************************************************************
 ƣ    void SYS_DisableWatchDog(void)
     ֹŹ
 ı    
     
     
   ֵ    
 ˵    
 ޸      汾          ޸            ޸
 -----------------------------------------------------------------------------
 2016/6/28      V1.0           cfwu          
 *******************************************************************************/
void SYS_DisableWatchDog(void)
{
   uint32_t tempReg = SYS_RST_CFG;
	 SYS_WR_PROTECT = 0x7a83;  //ѡ0x7a83
   tempReg &= ~BIT0;
   SYS_RST_CFG = tempReg;   
	 SYS_WR_PROTECT = 0;
}

/*******************************************************************************
 ƣ    void SYS_EnablePORFilter(void)
     POR˲
 ı    
     
     
   ֵ    
 ˵    
 ޸      汾          ޸            ޸
 -----------------------------------------------------------------------------
 2016/6/28      V1.0           cfwu          
 *******************************************************************************/
void SYS_EnablePORFilter(void)
{
   uint32_t tempReg = SYS_RST_CFG;
	 SYS_WR_PROTECT = 0x7a83;
   tempReg |= BIT1;
   SYS_RST_CFG = tempReg;   
	 SYS_WR_PROTECT = 0;
}

/*******************************************************************************
 ƣ    void SYS_DisablePORFilter(void)
     ֹPOR˲
 ı    
     
     
   ֵ    
 ˵    
 ޸      汾          ޸            ޸
 -----------------------------------------------------------------------------
 2016/6/28      V1.0           cfwu          
 *******************************************************************************/
void SYS_DisablePORFilter(void)
{
   uint32_t tempReg = SYS_RST_CFG;
   tempReg &= ~BIT1;
	 SYS_WR_PROTECT = 0x7a83;
   SYS_RST_CFG = tempReg; 
   SYS_WR_PROTECT = 0;	
}

/*******************************************************************************
 ƣ    void SYS_FeedDog(uint32_t timeOut)
     ι
 ı    
     Źʱʱ
     
   ֵ    
 ˵    
 ޸      汾          ޸            ޸
 -----------------------------------------------------------------------------
 2016/6/28      V1.0           cfwu          
 *******************************************************************************/
void SYS_FeedDog(uint32_t timeOut)
{
   SYS_WR_PROTECT = 0xCAFE;  //0xCAFE;
	
   if (timeOut == (uint32_t)SYS_WD_TimeOut64s)
   {
      SYS_WDT_CLR = 0x7989;    //1 00 1
   }
   else if(timeOut == (uint32_t)SYS_WD_TimeOut8s)
   {
      SYS_WDT_CLR = 0x798B;    //1 01 1
   }
	  else if(timeOut == (uint32_t)SYS_WD_TimeOut4s)
   {
      SYS_WDT_CLR = 0x798D;    //1 10 1
   }
	  else                      //SYS_WD_TimeOut2s
   {
      SYS_WDT_CLR = 0x798F;     //1 11 1
   } 
	 
	 SYS_WR_PROTECT = 0;
}

/*******************************************************************************
 ƣ    void SYS_ModuleClockCmd(uint32_t nModule, FuncState state)
     ģʱʹֹܺͣ
 ı    
     uint32_t nModuleӦģ
     
   ֵ    
 ˵    
 ޸      汾          ޸            ޸
 -----------------------------------------------------------------------------
 2016/6/28      V1.0           cfwu          
 *******************************************************************************/
void SYS_ModuleClockCmd(uint32_t nModule, FuncState state)
{
	SYS_WR_PROTECT = 0x7a83;
	if (state != DISABLE)
	{
		SYS_CLK_FEN |= nModule;
	}
	else
	{
		SYS_CLK_FEN &= ~nModule;
	}	
	SYS_WR_PROTECT = 0;
}

/*******************************************************************************
 ƣ    void SYS_SoftResetModule(uint32_t nModule)
     ģλ
 ı    
     uint32_t nModuleӦģ
     
   ֵ    
 ˵    
 ޸      汾          ޸            ޸
 -----------------------------------------------------------------------------
 2016/6/28      V1.0           cfwu          
 *******************************************************************************/
void SYS_SoftResetModule(uint32_t nModule)
{
	 SYS_WR_PROTECT = 0x7A83;
   SYS_SFT_RST = nModule;   
   SYS_WR_PROTECT = 1;
}

/************************ (C) COPYRIGHT LINKO SEMICONDUCTOR *****END OF FILE****/
